diff --git a/src/tools/msvc/vcregress.pl b/src/tools/msvc/vcregress.pl
index bd3dd2c..1e09c74 100644
--- a/src/tools/msvc/vcregress.pl
+++ b/src/tools/msvc/vcregress.pl
@@ -94,7 +94,7 @@ sub installcheck
 	my @args = (
 		"../../../$Config/pg_regress/pg_regress",
 		"--dlpath=.",
-		"--psqldir=../../../$Config/psql",
+		"--bindir=../../../$Config/psql",
 		"--schedule=${schedule}_schedule",
 		"--encoding=SQL_ASCII",
 		"--no-locale");
@@ -106,39 +106,56 @@ sub installcheck
 
 sub check
 {
+	my $cwd = getcwd();
+
+	system($0, 'install.pl', "$cwd/tmp_install");
+	my $status = $? >> 8;
+	exit $status if $status;
+
+	$ENV{PATH} = "$cwd/tmp_install/bin;$cwd/tmp_install/lib;$ENV{PATH}";
+
 	my @args = (
 		"../../../$Config/pg_regress/pg_regress",
 		"--dlpath=.",
-		"--psqldir=../../../$Config/psql",
+		"--bindir=",
 		"--schedule=${schedule}_schedule",
 		"--encoding=SQL_ASCII",
 		"--no-locale",
-		"--temp-install=./tmp_check",
-		"--top-builddir=\"$topdir\"");
+		"--temp-instance=./tmp_check");
 	push(@args, $maxconn)     if $maxconn;
 	push(@args, $temp_config) if $temp_config;
 	system(@args);
-	my $status = $? >> 8;
+	$status = $? >> 8;
 	exit $status if $status;
 }
 
 sub ecpgcheck
 {
 	chdir $startdir;
+
 	system("msbuild ecpg_regression.proj /p:config=$Config");
 	my $status = $? >> 8;
 	exit $status if $status;
+
+	my $cwd = getcwd();
+
+	system($0, 'install.pl', "$cwd/tmp_install");
+	$status = $? >> 8;
+	exit $status if $status;
+
+	$ENV{PATH} = "$cwd/tmp_install/bin;$cwd/tmp_install/lib;$ENV{PATH}";
+
 	chdir "$topdir/src/interfaces/ecpg/test";
 	$schedule = "ecpg";
 	my @args = (
 		"../../../../$Config/pg_regress_ecpg/pg_regress_ecpg",
-		"--psqldir=../../../$Config/psql",
+		"--bindir=",
 		"--dbname=regress1,connectdb",
 		"--create-role=connectuser,connectdb",
 		"--schedule=${schedule}_schedule",
 		"--encoding=SQL_ASCII",
 		"--no-locale",
-		"--temp-install=./tmp_chk",
+		"--temp-instance=./tmp_chk",
 		"--top-builddir=\"$topdir\"");
 	push(@args, $maxconn) if $maxconn;
 	system(@args);
@@ -153,7 +170,7 @@ sub isolationcheck
 		"../../../$Config/pg_isolation_regress");
 	my @args = (
 		"../../../$Config/pg_isolation_regress/pg_isolation_regress",
-		"--psqldir=../../../$Config/psql",
+		"--bindir=../../../$Config/psql",
 		"--inputdir=.",
 		"--schedule=./isolation_schedule");
 	push(@args, $maxconn) if $maxconn;
@@ -202,7 +219,7 @@ sub plcheck
 		print "Checking $lang\n";
 		my @args = (
 			"../../../$Config/pg_regress/pg_regress",
-			"--psqldir=../../../$Config/psql",
+			"--bindir=../../../$Config/psql",
 			"--dbname=pl_regression", @lang_args, @tests);
 		system(@args);
 		my $status = $? >> 8;
@@ -237,7 +254,7 @@ sub contribcheck
 		my @opts  = fetchRegressOpts();
 		my @args  = (
 			"../../$Config/pg_regress/pg_regress",
-			"--psqldir=../../$Config/psql",
+			"--bindir=../../$Config/psql",
 			"--dbname=contrib_regression", @opts, @tests);
 		system(@args);
 		my $status = $? >> 8;
